// -*- C++ -*-

#ifndef ESTIMATE_H
#define ESTIMATE_H

class est {
private:
    double _confidence;
    double _estimate;
    int _value;
public:
    est() : _confidence(0.0), _estimate(0.0), _value(0) {}
    explicit est(int value)
        : _confidence(1.0), _estimate(value), _value(value) {}

    est const &operator=(est const &rhs) {
        if (this != &rhs) {
            _confidence = rhs._confidence;
            _estimate = rhs._estimate;
            _value = rhs._value;
        }
        return *this;
    }

    est const &operator=(int value) {
        _confidence = 1.0;
        _estimate = value;
        _value = value;
        return *this;
    }

    double confidence() const { return _confidence; }
    double estimate() const { return _estimate; }

    int value() const { return _value; }
    operator int() const { return _value; }
};

#endif // ESTIMATE_H
