// -*- C++ -*-

#ifndef EVALUATE_H
#define EVALUATE_H

#include "package.h"
#include <string>
#include <vector>

using std::string;
using std::vector;

class action;
class loc_type;

extern float tuning;

/// eval the best action to do
string evaluate(package_vector &available);

class action {
public:
    enum type {
        move = 0,
        pick = 1,
        drop = 2
    };

    float value;
    int bid;
    type action_type;
    loc_type location;
    package_vector packages;
    char const *reason;
    
    explicit action(type t, char const *ir)
        : value(0.0), bid(1), action_type(t), location(),
          packages(), reason(ir)
        {}
    ~action() {
    }

    dir_type direction() const;
    string to_string() const;
};

void fill_explore(vector<action>& possible);
void fill_retrieve(vector<action>& possible,
                   package_vector const &available);
void fill_deliver(vector<action>& possible);


#endif // EVALUATE_H
