// -*- C++ -*-

#ifndef UTIL_H
#define UTIL_H

#include <iosfwd>
#include <string>
#include <sys/types.h>

using std::string;
using std::ostream;

bool readline(int fd, string &s);
void sendline(int fd, string const &s);

class stat {
public:
    stat();
    ~stat();
  
    void add_null();
    void add_double(double const &value);
  
    unsigned count() const { return _count; }
    unsigned count_all() const { return _count_all; }
    double sum() const { return _sum; }
    double sum_of_squares() const { return _sum_of_squares; }
    double min() const { return _min; }
    double max() const { return _max; }
  
    double average() const { return _count ? _sum / _count : 0.0; }
    double variance() const;
    double stdev() const;
private:
    unsigned _count;
    unsigned _count_all;
    double _sum;
    double _sum_of_squares;
    double _min;
    double _max;
};

ostream &operator<<(ostream &out, stat const &rhs);
    
#endif // UTIL_H
