#!/bin/sh

SIMULATOR=~/Simulator
CLIENT=../runme
errors=0
totaltests=0

SUITE=testsuite
if [ "$1" != "" ]; then
  SUITE=$1
fi

SLEEP=2
if [ "$2" != "" ]; then
  SLEEP=$2
fi

exec 0<$SUITE
while (expr 1 > /dev/null) do
  read servercmd 
  if [ "$servercmd" == "" ]; then
    break
  fi

  read expected 

  # start simulator
  echo "* Starting simulator w/cmdline $servercmd"
  $SIMULATOR $servercmd &
  SIMPID=$!
  echo "* PID = $SIMPID"
  disown $SIMPID #remove pid from job table of bash
  sleep $SLEEP

  # start client
  $CLIENT localhost 3001 >& client.out

  # wait

  # check
  actual=`tail -1 client.out`
  echo "* Expecting $expected and got $actual"

  delta=`expr $expected != $actual`
  if [ "$delta" == "1" ]; then
    echo "* Testcase $servercmd FAILED!"
  fi

  errors=`expr $errors + $delta`

  # kill
  kill $SIMPID 

  totaltests=`expr $totaltests + 1`
done

echo "* Test run completed, ran $totaltests, errors $errors"
rm -f *.log

